///////////////////////////////////////////////////////////////////////////////
//  This file is generated automatically using Prop (version 2.3.5),
//  last updated on Jun 18, 1997.
//  The original source file is "prop5.pcc".
///////////////////////////////////////////////////////////////////////////////

#define PROP_REWRITING_USED
#define PROP_QUARK_USED
#include <propdefs.h>
#line 1 "prop5.pcc"
//
//  Test the view mechanism
//

#include <assert.h>
#include <iostream.h>

class Expression
{
public:
   enum Variant { Int, Ident, Add, Sub, Mul, Div };
   virtual Variant get_variant() const = 0;
   virtual int  number() const;
   virtual const char * ident() const;
   virtual const Expression * child(int) const;
   virtual Expression *& child(int);
};

typedef Expression * Exp;

int Expression::number() const 
{ cerr << "unimplement Expression::number()\n"; exit(1); return 0; }

const char * Expression::ident() const 
{ cerr << "unimplement Expression::ident()\n"; exit(1); return 0; }

const Expression * Expression::child(int) const 
{ cerr << "unimplement Expression::child(int) const\n"; exit(1); return 0; }

Expression *& Expression::child(int) 
{ cerr << "unimplement Expression::child(int)\n"; exit(1); 
  static Expression * t = 0;
  return t; 
}

class Number : public Expression {
   int the_number;
public:
   Number(int n) : the_number(n) {}
   Variant get_variant() const { return Int; }
   int number() const { return the_number; }
   friend Expression * INT(int i) { return new Number(i); }
};

class Identifier : public Expression {
   const char * the_ident;
public:
   Identifier(const char * ident) : the_ident(ident) {}
   Variant get_variant() const { return Ident; }
   const char * ident() const { return the_ident; }
   friend Expression * ID(const char * id) { return new Identifier(id); }
};

class Operator : public Expression {
   char  op;
   Expression * children[2];
public:
   Operator(char o, const Expression* a, const Expression* b) : op(o) 
      { children[0] = (Expression*)a; children[1] = (Expression*)b; }
   Variant get_variant() const
   {  switch (op)
      { case '+':  return Add;
        case '-':  return Sub;
        case '*':  return Mul;
        case '/':  return Div;
	default:   return Add;
      }
   }
   Expression *& child(int i) { return children[i]; }
   const Expression * child(int i) const { return children[i]; }

   friend Expression * ADD(const Expression * a, const Expression * b)
   {  return new Operator('+',a,b); }
   friend Expression * SUB(const Expression * a, const Expression * b)
   {  return new Operator('-',a,b); }
   friend Expression * MUL(const Expression * a, const Expression * b)
   {  return new Operator('*',a,b); }
   friend Expression * DIV(const Expression * a, const Expression * b)
   {  return new Operator('/',a,b); }
};

#line 82 "prop5.pcc"
#line 90 "prop5.pcc"
#line 90 "prop5.pcc"
#line 90 "prop5.pcc"


ostream& operator << (ostream& s, Exp e)
{  
#line 93 "prop5.pcc"
#line 99 "prop5.pcc"
{
   switch (e->get_variant()) {
      case Expression::Int: {
#line 94 "prop5.pcc"
        return s << e->number(); 
#line 94 "prop5.pcc"
      } break;
      case Expression::Ident: {
#line 95 "prop5.pcc"
        return s << e->ident(); 
#line 95 "prop5.pcc"
      } break;
      case Expression::Add: {
#line 96 "prop5.pcc"
        return s << '(' << e->child(0) << " + " << e->child(1) << ')'; 
#line 96 "prop5.pcc"
      } break;
      case Expression::Sub: {
#line 97 "prop5.pcc"
        return s << '(' << e->child(0) << " - " << e->child(1) << ')'; 
#line 97 "prop5.pcc"
      } break;
      case Expression::Mul: {
#line 98 "prop5.pcc"
        return s << '(' << e->child(0) << " * " << e->child(1) << ')'; 
#line 98 "prop5.pcc"
      } break;
      case Expression::Div: {
#line 99 "prop5.pcc"
        return s << '(' << e->child(0) << " / " << e->child(1) << ')'; 
#line 99 "prop5.pcc"
      } break;
   }
}
#line 100 "prop5.pcc"
#line 100 "prop5.pcc"

}

int eval(Exp e)
{  
#line 104 "prop5.pcc"
#line 111 "prop5.pcc"
{
   switch (e->get_variant()) {
      case Expression::Int: {
#line 105 "prop5.pcc"
        return e->number(); 
#line 105 "prop5.pcc"
      } break;
      case Expression::Ident: {
#line 106 "prop5.pcc"
        return 0; 
#line 106 "prop5.pcc"
      } break;
      case Expression::Add: {
#line 107 "prop5.pcc"
        return eval(e->child(0)) + eval(e->child(1)); 
#line 107 "prop5.pcc"
      } break;
      case Expression::Sub: {
#line 108 "prop5.pcc"
        return eval(e->child(0)) - eval(e->child(1)); 
#line 108 "prop5.pcc"
      } break;
      case Expression::Mul: {
#line 109 "prop5.pcc"
        return eval(e->child(0)) * eval(e->child(1)); 
#line 109 "prop5.pcc"
      } break;
      case Expression::Div: {
         switch (e->child(1)->get_variant()) {
            case Expression::Int: {
               switch (e->child(1)->number()) {
                  case 0: {
#line 110 "prop5.pcc"
                    cerr << "Division by zero\n"; return 0; 
#line 110 "prop5.pcc"
                  } break;
                  default: {
                     L1:; 
#line 111 "prop5.pcc"
                    return eval(e->child(0)) / eval(e->child(1)); 
#line 111 "prop5.pcc"
                  }
               }
            } break;
            case Expression::Ident: { goto L1; } break;
            case Expression::Add: { goto L1; } break;
            case Expression::Sub: { goto L1; } break;
            case Expression::Mul: { goto L1; } break;
            case Expression::Div: { goto L1; } break;
         }
      } break;
   }
}
#line 112 "prop5.pcc"
#line 112 "prop5.pcc"

}

void simplify(Exp& e)
{

   
#line 118 "prop5.pcc"
#line 124 "prop5.pcc"
   extern void  _p_r_o_p_5co_X1_rewrite(Exp & );
   _p_r_o_p_5co_X1_rewrite(e);
#line 124 "prop5.pcc"
#line 124 "prop5.pcc"

}

int main()
{  Exp e = ADD(MUL(INT(5),INT(2)),DIV(INT(30),INT(6)));
   cout << "Expression = " << e << endl;
   cout << "Eval(" << e << ") = " << eval(e) << endl;
   simplify(e);
   cout << "Simplified = " << e << endl;
   assert(eval(e) == 15);
   return 0;
}
#line 136 "prop5.pcc"
class _p_r_o_p_5co_X1 : public BURS {
private:
   _p_r_o_p_5co_X1(const _p_r_o_p_5co_X1&);               // no copy constructor
   void operator = (const _p_r_o_p_5co_X1&); // no assignment
public:
   struct _p_r_o_p_5co_X1_StateRec * stack__, * stack_top__;
public:
   void labeler(const char *, int&, int);
   void labeler(Quark, int&, int);
          void  labeler(Exp & redex, int&, int);
   inline virtual void  operator () (Exp & redex) { int s; labeler(redex,s,0); }
private: 
   public:
      inline _p_r_o_p_5co_X1() {}
};
void  _p_r_o_p_5co_X1_rewrite(Exp &  _x_) 
{  _p_r_o_p_5co_X1 _r_;
   _r_(_x_);
}

///////////////////////////////////////////////////////////////////////////////
//
// This macro can be redefined by the user for debugging
//
///////////////////////////////////////////////////////////////////////////////
#ifndef DEBUG__p_r_o_p_5co_X1
#define DEBUG__p_r_o_p_5co_X1(repl,redex,file,line,rule) repl
#else
static const char * _p_r_o_p_5co_X1_file_name = "prop5.pcc";
#endif

static const TreeTables::ShortState _p_r_o_p_5co_X1_theta_2[2][2] = {
   { 0, 0 },
   { 0, 2 }
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_theta_3[2][2] = {
   { 0, 0 },
   { 0, 3 }
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_theta_4[2][2] = {
   { 0, 0 },
   { 0, 4 }
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_theta_5[2][2] = {
   { 0, 0 },
   { 0, 5 }
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_2_0[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_2_1[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_3_0[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_3_1[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_4_0[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_4_1[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_5_0[6] = {
   0, 1, 0, 0, 0, 0
};


static const TreeTables::ShortState _p_r_o_p_5co_X1_mu_5_1[6] = {
   0, 1, 0, 0, 0, 0
};


inline void  _p_r_o_p_5co_X1::labeler(char const * redex,int& s__,int)
{
   {
s__ = 0;
   }
}

inline void  _p_r_o_p_5co_X1::labeler(Quark redex,int& s__,int)
{
   {
s__ = 0;
   }
}

void  _p_r_o_p_5co_X1::labeler (Exp & redex, int& s__, int r__)
{
replacement__:
   switch(redex->get_variant()) {
      case Expression::Int: { 
         int s0__;
         s0__ = 0; // int = _0->number()
         s__ = 1;} break;
      case Expression::Ident: { 
         int s0__;
         labeler(redex->ident(), s0__, r__);
         s__ = 0;} break;
      case Expression::Add: { 
         int s0__;
         int s1__;
         labeler(redex->child(0), s0__, r__);
         labeler(redex->child(1), s1__, r__);
         s__ = _p_r_o_p_5co_X1_theta_2[_p_r_o_p_5co_X1_mu_2_0[s0__]][_p_r_o_p_5co_X1_mu_2_1[s1__]]; } break;
      case Expression::Sub: { 
         int s0__;
         int s1__;
         labeler(redex->child(0), s0__, r__);
         labeler(redex->child(1), s1__, r__);
         s__ = _p_r_o_p_5co_X1_theta_3[_p_r_o_p_5co_X1_mu_3_0[s0__]][_p_r_o_p_5co_X1_mu_3_1[s1__]]; } break;
      case Expression::Mul: { 
         int s0__;
         int s1__;
         labeler(redex->child(0), s0__, r__);
         labeler(redex->child(1), s1__, r__);
         s__ = _p_r_o_p_5co_X1_theta_4[_p_r_o_p_5co_X1_mu_4_0[s0__]][_p_r_o_p_5co_X1_mu_4_1[s1__]]; } break;
      default: { 
         int s0__;
         int s1__;
         labeler(redex->child(0), s0__, r__);
         labeler(redex->child(1), s1__, r__);
         s__ = _p_r_o_p_5co_X1_theta_5[_p_r_o_p_5co_X1_mu_5_0[s0__]][_p_r_o_p_5co_X1_mu_5_1[s1__]]; } break;
   }
   switch (s__) {
      case 5: {
#line 123 "prop5.pcc"
         { redex = DEBUG__p_r_o_p_5co_X1(INT((redex->child(0)->number() / redex->child(1)->number())),redex,_p_r_o_p_5co_X1_file_name,123,"DIV (INT i, INT j): ...");
           r__ = 1; goto replacement__; }
#line 124 "prop5.pcc"
} break;
      case 4: {
#line 122 "prop5.pcc"
         { redex = DEBUG__p_r_o_p_5co_X1(INT((redex->child(0)->number() * redex->child(1)->number())),redex,_p_r_o_p_5co_X1_file_name,122,"MUL (INT i, INT j): ...");
           r__ = 1; goto replacement__; }
#line 123 "prop5.pcc"
} break;
      case 3: {
#line 121 "prop5.pcc"
         { redex = DEBUG__p_r_o_p_5co_X1(INT((redex->child(0)->number() - redex->child(1)->number())),redex,_p_r_o_p_5co_X1_file_name,121,"SUB (INT i, INT j): ...");
           r__ = 1; goto replacement__; }
#line 122 "prop5.pcc"
} break;
      case 2: {
#line 120 "prop5.pcc"
         { redex = DEBUG__p_r_o_p_5co_X1(INT((redex->child(0)->number() + redex->child(1)->number())),redex,_p_r_o_p_5co_X1_file_name,120,"ADD (INT i, INT j): ...");
           r__ = 1; goto replacement__; }
#line 121 "prop5.pcc"
} break;
   }
   
}

/*
------------------------------- Statistics -------------------------------
Merge matching rules         = yes
Number of DFA nodes merged   = 6
Number of ifs generated      = 0
Number of switches generated = 4
Number of labels             = 1
Number of gotos              = 5
Adaptive matching            = disabled
Fast string matching         = disabled
Inline downcasts             = disabled
--------------------------------------------------------------------------
*/
