///////////////////////////////////////////////////////////////////////////////
//  This file is generated automatically using Prop (version 2.3.5),
//  last updated on Jun 18, 1997.
//  The original source file is "test_gc4.pcc".
///////////////////////////////////////////////////////////////////////////////

#define PROP_GARBAGE_COLLECTION_USED
#include <propdefs.h>
#line 1 "test_gc4.pcc"
//////////////////////////////////////////////////////////////////////////////
//  Program to test garbage collection with pointer sharing.
//////////////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>
#include <AD/gc/gcheaps.h>

#define NODES (256 * 1024) 
#define TRIALS 10
#define SHARING

//////////////////////////////////////////////////////////////////////////////
//  Datatype TREE is just a simple binary tree (actually a dag in our case).
//////////////////////////////////////////////////////////////////////////////
#line 18 "test_gc4.pcc"
#line 18 "test_gc4.pcc"
///////////////////////////////////////////////////////////////////////////////
//
// Forward class definition for TREE
//
///////////////////////////////////////////////////////////////////////////////
#ifndef datatype_TREE_defined
#define datatype_TREE_defined
   class a_TREE;
   typedef a_TREE * TREE;
#endif

#  define empty (TREE)0

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor TREE::node
//
///////////////////////////////////////////////////////////////////////////////
class a_TREE : public GCObject {
public:
#line 18 "test_gc4.pcc"
   TREE _1; int _2; TREE _3; 
   inline a_TREE (TREE x_1, int x_2, TREE x_3)
    : _1(x_1), _2(x_2), _3(x_3)
   {
   }
   inline virtual ~a_TREE()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};
inline int boxed(const a_TREE * x) { return x != 0; }
inline int untag(const a_TREE * x) { return x ? 1 : 0; }
///////////////////////////////////////////////////////////////////////////////
//
// Datatype constructor functions for TREE
//
///////////////////////////////////////////////////////////////////////////////
inline a_TREE * node (TREE x_1, int x_2, TREE x_3)
{
   return new a_TREE (x_1, x_2, x_3);
}
///////////////////////////////////////////////////////////////////////////////
//
// Downcasting functions for TREE
//
///////////////////////////////////////////////////////////////////////////////


#line 18 "test_gc4.pcc"
#line 18 "test_gc4.pcc"

#line 19 "test_gc4.pcc"
#line 19 "test_gc4.pcc"
///////////////////////////////////////////////////////////////////////////////
//
// Interface specification of datatype TREE
//
///////////////////////////////////////////////////////////////////////////////
#line 19 "test_gc4.pcc"


///////////////////////////////////////////////////////////////////////////////
//
// Instantiation of datatype TREE
//
///////////////////////////////////////////////////////////////////////////////
#line 19 "test_gc4.pcc"
void a_TREE::trace(GC * gc__)
{
   this->_1 = (TREE )gc__->trace(this->_1); // TREE
   // omitted int
   this->_3 = (TREE )gc__->trace(this->_3); // TREE
}



#line 19 "test_gc4.pcc"
#line 19 "test_gc4.pcc"


//////////////////////////////////////////////////////////////////////////////
//  Compute the sum of all nodes of a tree
//////////////////////////////////////////////////////////////////////////////
int sum (TREE t)
{  
#line 25 "test_gc4.pcc"
#line 28 "test_gc4.pcc"
{
   if (t) {
#line 27 "test_gc4.pcc"
    return sum(t->_1) + t->_2 + sum(t->_3);
      
#line 28 "test_gc4.pcc"
   } else {
#line 26 "test_gc4.pcc"
  return 0;
      
#line 27 "test_gc4.pcc"
   }
}
#line 28 "test_gc4.pcc"
#line 28 "test_gc4.pcc"

}

//////////////////////////////////////////////////////////////////////////////
//  Count the number of pointer sharings. 
//////////////////////////////////////////////////////////////////////////////
int sharing (TREE t)
{  
#line 35 "test_gc4.pcc"
#line 39 "test_gc4.pcc"
{
   if (t) {
#line 37 "test_gc4.pcc"
    return sharing(t->_1) + sharing(t->_3) 
      + ((t->_1 != empty && t->_1 == t->_3) ? 1 : 0);
      
#line 39 "test_gc4.pcc"
   } else {
#line 36 "test_gc4.pcc"
  return 0;
      
#line 37 "test_gc4.pcc"
   }
}
#line 39 "test_gc4.pcc"
#line 39 "test_gc4.pcc"

}

//////////////////////////////////////////////////////////////////////////////
//  Compute the size of a tree
//////////////////////////////////////////////////////////////////////////////
int size (TREE t)
{  
#line 46 "test_gc4.pcc"
#line 49 "test_gc4.pcc"
{
   if (t) {
#line 48 "test_gc4.pcc"
    return size(t->_1) + 1 + size(t->_3);
      
#line 49 "test_gc4.pcc"
   } else {
#line 47 "test_gc4.pcc"
  return 0;
      
#line 48 "test_gc4.pcc"
   }
}
#line 49 "test_gc4.pcc"
#line 49 "test_gc4.pcc"

}

//////////////////////////////////////////////////////////////////////////////
//  Check a tree for correctness.
//////////////////////////////////////////////////////////////////////////////
void check (TREE t)
{  
#line 56 "test_gc4.pcc"
#line 63 "test_gc4.pcc"
{
   if (t) {
#line 58 "test_gc4.pcc"
  
      assert (HM::is_mapped(t) && 
              HM::page_gc(t) == GC::get_default_gc().gc_id());
      assert (HM::get_object_map().is_marked(t));
      check(t->_1); check(t->_3); 
      
#line 63 "test_gc4.pcc"
   } else {
#line 57 "test_gc4.pcc"
  return;
      
#line 58 "test_gc4.pcc"
   }
}
#line 63 "test_gc4.pcc"
#line 63 "test_gc4.pcc"

}

//////////////////////////////////////////////////////////////////////////////
//  Routine to make a random tree of a certain size.
//////////////////////////////////////////////////////////////////////////////
TREE make_tree(int n)
{  if (n == 0) return empty;
   int split = rand() % n;
   int data  = rand() % n;
#ifdef SHARING
   if ((n % 2 == 1) && (rand() % 2 == 1)) {
      TREE t = make_tree(n/2);
      return node(t, data, t);
   }
#endif
   return node(make_tree(split), data, make_tree(n - split - 1));
}

void testing()
{  
   for (int trial = 1; trial <= TRIALS; trial++) {
       cout << "Trial number " << trial << '\n' << flush;
       TREE tree1    = make_tree(NODES);
       int  size1    = size(tree1);
       int  sum1     = sum(tree1);
       int  sharing1 = sharing (tree1);
       check(tree1);

       cout << "Size = " << size1 << " check sum = " << sum1 
            << " pointer sharing = " << sharing1 << '\n' << flush;

       make_tree(NODES);              // this just generates a lot of garbage

       // Now traverse the tree check things.
       assert(size(tree1)     == NODES);
       assert(sum(tree1)      == sum1);
       assert(sharing(tree1)  == sharing1);
       check(tree1);
       cout << "Trial number " << trial << " has passed\n";
   }
}

int main()
{  
   cout << 
     "This test generate random dags and try to see if garbage collection\n"
     "works on preserving pointer sharing correctly.  I'll do this " 
      << TRIALS << " times.\n";
   srand(getpid()); 
   testing();
   // force an explicit garbage collection
   cout << "Finished.  Now I'm forcing another garbage collection to clean\n"
           "things up.  There should be very little garbage left at the end.\n";
   GC::garbage_collect();  
   return 0;
}
#line 120 "test_gc4.pcc"
/*
------------------------------- Statistics -------------------------------
Merge matching rules         = yes
Number of DFA nodes merged   = 0
Number of ifs generated      = 4
Number of switches generated = 0
Number of labels             = 0
Number of gotos              = 0
Adaptive matching            = disabled
Fast string matching         = disabled
Inline downcasts             = disabled
--------------------------------------------------------------------------
*/
