///////////////////////////////////////////////////////////////////////////////
//  This file is generated automatically using Prop (version 2.3.5),
//  last updated on Jun 18, 1997.
//  The original source file is "test_gc5.pcc".
///////////////////////////////////////////////////////////////////////////////

#define PROP_REWRITING_USED
#define PROP_GARBAGE_COLLECTION_USED
#define PROP_QUARK_USED
#include <propdefs.h>
#line 1 "test_gc5.pcc"
//
//  Testing finalization with garbage collection.
//  We use the class BGC_F (BGC with finalization) for garbage collection.
//  In addition of reclaiming garbage, BGC_F will also call the finalization
//  method (the destructor) for each object freed.
//
#include <iostream.h>

//
//  The following auxiliary class keeps track of allocation and finalization.
//
class LOGGER {
public:
   static int allocation_count;
   static int deallocation_count;
   LOGGER() { allocation_count++; }
  ~LOGGER() { deallocation_count++; }
};

int LOGGER::allocation_count   = 0;
int LOGGER::deallocation_count = 0;

//
//  Define an algebraic datatype.  Currently, rewriting can only be 
//  performed on datatypes(and not views) in Prop.  
//  If replacement is to be performed on a datatype, then it should
//  be declared using the ``rewrite'' qualifier.
//  In this example, we'll use garbage collection with rewriting.
//
//  We'll inherit from LOGGER so that allocation and finalization
//  of each EXP cell is logged.
//
#line 33 "test_gc5.pcc"
#line 41 "test_gc5.pcc"
///////////////////////////////////////////////////////////////////////////////
//
// Forward class definition for EXP
//
///////////////////////////////////////////////////////////////////////////////
#ifndef datatype_EXP_defined
#define datatype_EXP_defined
   class a_EXP;
   typedef a_EXP * EXP;
#endif

#  define om (EXP)0

///////////////////////////////////////////////////////////////////////////////
//
// Base class for datatype EXP
//
///////////////////////////////////////////////////////////////////////////////
class a_EXP : public GCObject, public LOGGER, public TermObj {
public:
   enum Tag_EXP {
      tag_num = 0, tag_var = 1, tag_add = 2, 
      tag_sub = 3, tag_mul = 4, tag_div = 5
   };

public:
   const Tag_EXP tag__; // variant tag
protected:
   inline a_EXP(Tag_EXP t__) : tag__(t__) {}
public:
   inline virtual ~a_EXP()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};
inline int boxed(const a_EXP * x) { return x != 0; }
inline int untag(const a_EXP * x) { return x ? (x->tag__+1) : 0; }
///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::num
//
///////////////////////////////////////////////////////////////////////////////
class EXP_num : public a_EXP {
public:
#line 35 "test_gc5.pcc"
   int num; 
   inline EXP_num (int x_num)
    : a_EXP(tag_num), num(x_num)
   {
   }
   inline ~EXP_num()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::var
//
///////////////////////////////////////////////////////////////////////////////
class EXP_var : public a_EXP {
public:
#line 36 "test_gc5.pcc"
   char var; 
   inline EXP_var (char x_var)
    : a_EXP(tag_var), var(x_var)
   {
   }
   inline ~EXP_var()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::add
//
///////////////////////////////////////////////////////////////////////////////
class EXP_add : public a_EXP {
public:
#line 37 "test_gc5.pcc"
   EXP _1; EXP _2; 
   inline EXP_add (EXP x_1, EXP x_2)
    : a_EXP(tag_add), _1(x_1), _2(x_2)
   {
   }
   inline ~EXP_add()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::sub
//
///////////////////////////////////////////////////////////////////////////////
class EXP_sub : public a_EXP {
public:
#line 38 "test_gc5.pcc"
   EXP _1; EXP _2; 
   inline EXP_sub (EXP x_1, EXP x_2)
    : a_EXP(tag_sub), _1(x_1), _2(x_2)
   {
   }
   inline ~EXP_sub()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::mul
//
///////////////////////////////////////////////////////////////////////////////
class EXP_mul : public a_EXP {
public:
#line 39 "test_gc5.pcc"
   EXP _1; EXP _2; 
   inline EXP_mul (EXP x_1, EXP x_2)
    : a_EXP(tag_mul), _1(x_1), _2(x_2)
   {
   }
   inline ~EXP_mul()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Class for datatype constructor EXP::div
//
///////////////////////////////////////////////////////////////////////////////
class EXP_div : public a_EXP {
public:
#line 40 "test_gc5.pcc"
   EXP _1; EXP _2; 
   inline EXP_div (EXP x_1, EXP x_2)
    : a_EXP(tag_div), _1(x_1), _2(x_2)
   {
   }
   inline ~EXP_div()
   {
   }
   ////////////////////////////////////////////////////////////////////////////
   //
   // Method for garbage collection tracing
   //
   ////////////////////////////////////////////////////////////////////////////
protected:
   virtual void trace(GC *);
public:
};

///////////////////////////////////////////////////////////////////////////////
//
// Datatype constructor functions for EXP
//
///////////////////////////////////////////////////////////////////////////////
inline a_EXP * num (int x_num)
{
   return new EXP_num (x_num);
}
inline a_EXP * var (char x_var)
{
   return new EXP_var (x_var);
}
inline a_EXP * add (EXP x_1, EXP x_2)
{
   return new EXP_add (x_1, x_2);
}
inline a_EXP * sub (EXP x_1, EXP x_2)
{
   return new EXP_sub (x_1, x_2);
}
inline a_EXP * mul (EXP x_1, EXP x_2)
{
   return new EXP_mul (x_1, x_2);
}
inline a_EXP * div (EXP x_1, EXP x_2)
{
   return new EXP_div (x_1, x_2);
}
///////////////////////////////////////////////////////////////////////////////
//
// Downcasting functions for EXP
//
///////////////////////////////////////////////////////////////////////////////
inline EXP_num * _num(const a_EXP * _x_) { return (EXP_num *)_x_; }
inline EXP_var * _var(const a_EXP * _x_) { return (EXP_var *)_x_; }
inline EXP_add * _add(const a_EXP * _x_) { return (EXP_add *)_x_; }
inline EXP_sub * _sub(const a_EXP * _x_) { return (EXP_sub *)_x_; }
inline EXP_mul * _mul(const a_EXP * _x_) { return (EXP_mul *)_x_; }
inline EXP_div * _div(const a_EXP * _x_) { return (EXP_div *)_x_; }

#line 41 "test_gc5.pcc"
#line 41 "test_gc5.pcc"


//
//  Datatype instantiation generates any additional methods and definitions.
//  In this case garbage collection tracing methods are generated.
//  As always, this should be placed in an implementation file.
//
#line 48 "test_gc5.pcc"
#line 48 "test_gc5.pcc"
///////////////////////////////////////////////////////////////////////////////
//
// Interface specification of datatype EXP
//
///////////////////////////////////////////////////////////////////////////////
#line 48 "test_gc5.pcc"


///////////////////////////////////////////////////////////////////////////////
//
// Instantiation of datatype EXP
//
///////////////////////////////////////////////////////////////////////////////
#line 48 "test_gc5.pcc"
void a_EXP::trace(GC * gc__)
{
}

void EXP_num::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   // omitted int
}

void EXP_var::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   // omitted char
}

void EXP_add::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   this->_1 = (EXP )gc__->trace(this->_1); // EXP
   this->_2 = (EXP )gc__->trace(this->_2); // EXP
}

void EXP_sub::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   this->_1 = (EXP )gc__->trace(this->_1); // EXP
   this->_2 = (EXP )gc__->trace(this->_2); // EXP
}

void EXP_mul::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   this->_1 = (EXP )gc__->trace(this->_1); // EXP
   this->_2 = (EXP )gc__->trace(this->_2); // EXP
}

void EXP_div::trace(GC * gc__)
{
   // call to method a_EXP::trace() has been optimized out
   this->_1 = (EXP )gc__->trace(this->_1); // EXP
   this->_2 = (EXP )gc__->trace(this->_2); // EXP
}



#line 48 "test_gc5.pcc"
#line 48 "test_gc5.pcc"


//
//  Define a method that prints an expression.  This is a simple
//  inductive definition
//
ostream& operator << (ostream& f, EXP e)
{  
#line 55 "test_gc5.pcc"
#line 62 "test_gc5.pcc"
{
   if (e) {
      switch (e->tag__) {
         case a_EXP::tag_num: {
#line 57 "test_gc5.pcc"
           return f << _num(e)->num; 
#line 57 "test_gc5.pcc"
            } break;
         case a_EXP::tag_var: {
#line 58 "test_gc5.pcc"
           return f << _var(e)->var; 
#line 58 "test_gc5.pcc"
            } break;
         case a_EXP::tag_add: {
#line 59 "test_gc5.pcc"
           return f << '(' << _add(e)->_1 << " + " << _add(e)->_2 << ')'; 
#line 59 "test_gc5.pcc"
            } break;
         case a_EXP::tag_sub: {
#line 60 "test_gc5.pcc"
           return f << '(' << _sub(e)->_1 << " - " << _sub(e)->_2 << ')'; 
#line 60 "test_gc5.pcc"
            } break;
         case a_EXP::tag_mul: {
#line 61 "test_gc5.pcc"
           return f << '(' << _mul(e)->_1 << " * " << _mul(e)->_2 << ')'; 
#line 61 "test_gc5.pcc"
            } break;
         default: {
#line 62 "test_gc5.pcc"
           return f << '(' << _div(e)->_1 << " / " << _div(e)->_2 << ')'; 
#line 62 "test_gc5.pcc"
            } break;
      }
   } else {
#line 56 "test_gc5.pcc"
     return f << "om"; 
#line 56 "test_gc5.pcc"
   }
}
#line 63 "test_gc5.pcc"
#line 63 "test_gc5.pcc"

}

//
//  Define the interface to a ``rewriting class.''  A rewriting class 
//  is simply a C++ class with rewriting rules attached.  In real programs
//  this definition should be placed in some definition (i.e. .ph) files.
//  
//  In parenthesis, we must list all datatypes involved.   Unlike
//  simple pattern matching, rewriting can involve a set of mutually
//  recursive (or mutually exclusive, if desired) datatype definitions.
//  So in general this is a comma delimited list.   
//
//  In this example it involves only the datatype EXP.
//
#line 78 "test_gc5.pcc"
#line 82 "test_gc5.pcc"
class Simplify : public BURS {
private:
   Simplify(const Simplify&);               // no copy constructor
   void operator = (const Simplify&); // no assignment
public:
   struct Simplify_StateRec * stack__, * stack_top__;
public:
   void labeler(const char *, int&, int);
   void labeler(Quark, int&, int);
          void  labeler(EXP & redex, int&, int);
   inline virtual void  operator () (EXP & redex) { int s; labeler(redex,s,0); }
private:
#line 79 "test_gc5.pcc"
 // nothing here for now.
   public:
      Simplify() {}
#line 82 "test_gc5.pcc"
};
#line 82 "test_gc5.pcc"
#line 82 "test_gc5.pcc"


//
//  Now we define the rewriting rules in the rewriting class Simplify.  These
//  rules should be placed in an implementation file (.pcc, .pC, .pc++ etc).
//
//  In this brief sample class we have some rules that perform 
//  simple constant folding and strength reduction.
//
//  Currently, all the rules for a rewrite class must be placed in
//  the same rewrite construct.  This will probably change in the future
//  once I work out the details on incremental tree automata compilation.
//
#line 95 "test_gc5.pcc"
#line 111 "test_gc5.pcc"
///////////////////////////////////////////////////////////////////////////////
//
// This macro can be redefined by the user for debugging
//
///////////////////////////////////////////////////////////////////////////////
#ifndef DEBUG_Simplify
#define DEBUG_Simplify(repl,redex,file,line,rule) repl
#else
static const char * Simplify_file_name = "test_gc5.pcc";
#endif

static const TreeTables::Offset Simplify_accept_base [ 13 ] = {
   0, 0, 1, 3, 7, 9, 11, 14, 18, 26, 30, 33, 38
};
static const TreeTables::ShortRule Simplify_accept_vector [ 40 ] = {
   -1, 1, -1, 0, 1, 10, -1, 0, -1, 2, -1, 2, 11, -1, 3, 5, 
   7, -1, 3, 4, 5, 6, 7, 8, 12, -1, 4, 6, 8, -1, 9, 14, 
   -1, 9, 13, 14, 15, -1, 15, -1
};
static const TreeTables::ShortState Simplify_theta_3[2][2] = {
   { 0, 2 },
   { 4, 3 }
};


static const TreeTables::ShortState Simplify_theta_4[2][2] = {
   { 0, 5 },
   { 0, 6 }
};


static const TreeTables::ShortState Simplify_theta_5[2][2] = {
   { 0, 7 },
   { 9, 8 }
};


static const TreeTables::ShortState Simplify_theta_6[2][2] = {
   { 0, 10 },
   { 12, 11 }
};


static const TreeTables::ShortState Simplify_mu_3_0[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_3_1[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_4_0[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_4_1[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_5_0[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_5_1[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_6_0[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


static const TreeTables::ShortState Simplify_mu_6_1[13] = {
   0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


inline void  Simplify::labeler(char const * redex,int& s__,int)
{
   {
s__ = 0;
   }
}

inline void  Simplify::labeler(Quark redex,int& s__,int)
{
   {
s__ = 0;
   }
}

void  Simplify::labeler (EXP & redex, int& s__, int r__)
{
replacement__:
   int cached__;
   if (r__ && boxed(redex) && (cached__ = redex->get_rewrite_state()) != BURS::undefined_state)
   { s__ = cached__; return; }
   if ((redex)) {
      switch(redex->tag__) {
         case a_EXP::tag_num: { 
            int s0__;
            s0__ = 0; // int
            s__ = 1;} break;
         case a_EXP::tag_var: { 
            int s0__;
            s0__ = 0; // char
            s__ = 0;} break;
         case a_EXP::tag_add: { 
            int s0__;
            int s1__;
            labeler(_add(redex)->_1, s0__, r__);
            labeler(_add(redex)->_2, s1__, r__);
            s__ = Simplify_theta_3[Simplify_mu_3_0[s0__]][Simplify_mu_3_1[s1__]]; } break;
         case a_EXP::tag_sub: { 
            int s0__;
            int s1__;
            labeler(_sub(redex)->_1, s0__, r__);
            labeler(_sub(redex)->_2, s1__, r__);
            s__ = Simplify_theta_4[Simplify_mu_4_0[s0__]][Simplify_mu_4_1[s1__]]; } break;
         case a_EXP::tag_mul: { 
            int s0__;
            int s1__;
            labeler(_mul(redex)->_1, s0__, r__);
            labeler(_mul(redex)->_2, s1__, r__);
            s__ = Simplify_theta_5[Simplify_mu_5_0[s0__]][Simplify_mu_5_1[s1__]]; } break;
         default: { 
            int s0__;
            int s1__;
            labeler(_div(redex)->_1, s0__, r__);
            labeler(_div(redex)->_2, s1__, r__);
            s__ = Simplify_theta_6[Simplify_mu_6_0[s0__]][Simplify_mu_6_1[s1__]]; } break;
      }
   } else {s__ = 0;
   }
   const TreeTables::ShortRule * o__ = Simplify_accept_vector + Simplify_accept_base[s__];
accept__:
   switch (*o__) {
      case 15: if ((_num(_div(redex)->_1)->num == 0))
      {
#line 111 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_div(redex)->_1,redex,Simplify_file_name,111,"div (zero as num _, x) | (redex!div.1!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 111 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 14: if ((_num(_div(redex)->_2)->num == 0))
      {
#line 110 "test_gc5.pcc"
        /* cout << "Division by zero!\n"; */ 
#line 110 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 13: if ((_num(_div(redex)->_2)->num != 0))
      {
#line 109 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num((_num(_div(redex)->_1)->num / _num(_div(redex)->_2)->num)),redex,Simplify_file_name,109,"div (num x, num y) | (redex!div.2!num != 0): ...");
           r__ = 1; goto replacement__; }
#line 109 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 12: {
#line 108 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num((_num(_mul(redex)->_1)->num * _num(_mul(redex)->_2)->num)),redex,Simplify_file_name,108,"mul (num x, num y): ...");
           r__ = 1; goto replacement__; }
#line 108 "test_gc5.pcc"
} break;
      case 11: {
#line 107 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num((_num(_sub(redex)->_1)->num - _num(_sub(redex)->_2)->num)),redex,Simplify_file_name,107,"sub (num x, num y): ...");
           r__ = 1; goto replacement__; }
#line 107 "test_gc5.pcc"
} break;
      case 10: {
#line 106 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num((_num(_add(redex)->_1)->num + _num(_add(redex)->_2)->num)),redex,Simplify_file_name,106,"add (num x, num y): ...");
           r__ = 1; goto replacement__; }
#line 106 "test_gc5.pcc"
} break;
      case 9: if ((_num(_div(redex)->_2)->num == 1))
      {
#line 105 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_div(redex)->_1,redex,Simplify_file_name,105,"div (x, num _) | (redex!div.2!num == 1): ...");
           r__ = 1; goto replacement__; }
#line 105 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 8: if ((_num(_mul(redex)->_1)->num == 2))
      {
#line 104 "test_gc5.pcc"
         { redex = DEBUG_Simplify(add(_mul(redex)->_2,_mul(redex)->_2),redex,Simplify_file_name,104,"mul (num _, x) | (redex!mul.1!num == 2): ...");
           r__ = 1; goto replacement__; }
#line 104 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 7: if ((_num(_mul(redex)->_2)->num == 2))
      {
#line 103 "test_gc5.pcc"
         { redex = DEBUG_Simplify(add(_mul(redex)->_1,_mul(redex)->_1),redex,Simplify_file_name,103,"mul (x, num _) | (redex!mul.2!num == 2): ...");
           r__ = 1; goto replacement__; }
#line 103 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 6: if ((_num(_mul(redex)->_1)->num == 1))
      {
#line 102 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_mul(redex)->_2,redex,Simplify_file_name,102,"mul (num _, x) | (redex!mul.1!num == 1): ...");
           r__ = 1; goto replacement__; }
#line 102 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 5: if ((_num(_mul(redex)->_2)->num == 1))
      {
#line 101 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_mul(redex)->_1,redex,Simplify_file_name,101,"mul (x, num _) | (redex!mul.2!num == 1): ...");
           r__ = 1; goto replacement__; }
#line 101 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 4: if ((_num(_mul(redex)->_1)->num == 0))
      {
#line 100 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num(0),redex,Simplify_file_name,100,"mul (num _, x) | (redex!mul.1!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 100 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 3: if ((_num(_mul(redex)->_2)->num == 0))
      {
#line 99 "test_gc5.pcc"
         { redex = DEBUG_Simplify(num(0),redex,Simplify_file_name,99,"mul (x, num _) | (redex!mul.2!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 99 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 2: if ((_num(_sub(redex)->_2)->num == 0))
      {
#line 98 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_sub(redex)->_1,redex,Simplify_file_name,98,"sub (x, num _) | (redex!sub.2!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 98 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 1: if ((_num(_add(redex)->_2)->num == 0))
      {
#line 97 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_add(redex)->_1,redex,Simplify_file_name,97,"add (x, num _) | (redex!add.2!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 97 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
      case 0: if ((_num(_add(redex)->_1)->num == 0))
      {
#line 96 "test_gc5.pcc"
         { redex = DEBUG_Simplify(_add(redex)->_2,redex,Simplify_file_name,96,"add (num _, x) | (redex!add.1!num == 0): ...");
           r__ = 1; goto replacement__; }
#line 96 "test_gc5.pcc"
}
      else { ++o__; goto accept__; } break;
   }
   if (boxed(redex)) {
      redex->set_rewrite_state(s__);
   }
   
}

#line 112 "test_gc5.pcc"
#line 112 "test_gc5.pcc"


//
//  Now defines the function that uses all this stuff.
//
void do_my_stuff()
{
   //
   // Instantiate a rewriting class 
   //
   Simplify sim;
   EXP t1, term, term2;

   for (int trials = 1; trials < 10000; trials++) {
      //
      // (0 + x * 2) / (1 * 5 + 1 * 3) / (0 / y);
      //
      t1 = div(div(add(num(0), mul(var('x'),num(2))), 
                   add(mul(num(1), num(5)),mul(num(1),num(3)))),
               div(num(0),var('y')));
      term = mul(t1,t1);

      //
      //  Rewrite the big term above.
      // 
      // cout << "Before: " << term << '\n';
      sim(term);
      // cout << "After: " << term << '\n';

      //
      //  Rewrite it again.  It should have no effect since the term
      //  is already in normal form.
      //
      sim(term);
      // cout << "Again (should have no effect): " << term << '\n';

      //
      //  Rewrite some other term.
      //
      term2 = add(sub(num(3),num(3)), var('z'));
      // cout << "Before: " << term2 << '\n';
      sim(term2);
      // cout << "After: " << term2 << '\n';
   }
}

int main()
{
   //
   // Turn on finalization
   //
   GC::get_default_gc().set_finalization(true); 

   cout << "Now performing some rewrites and generating some garbage.\n"
           "(See also the test 'test_rc1')\n" << flush;
   // GC::get_default_gc().set_verbosity(0);
   do_my_stuff();
   cout << "Finished.  Now I'll force one more GC to clean up.\n"
           "There should be at most a few kilobytes of retention at the end.\n"
           "The GC should be able to recognized a large part of the heap as\n"
           "garbage.  See below:\n";
   // GC::get_default_gc().set_verbosity(1);
   GC::garbage_collect();
   cout << "The following allocation count should be very close to the\n"
           "finalization count.  If they are very far apart that means\n"
           "something is wrong.\n" 
        << "Allocation count        = " << LOGGER::allocation_count << '\n'
        << "Number of finalizations = " << LOGGER::deallocation_count << '\n';
   if (GC::get_default_gc().statistics().bytes_used <= 1024)
      cout << "Seems like it's working well for your platform.   Lucky dog!\n";
   return 0;
}
#line 184 "test_gc5.pcc"
/*
------------------------------- Statistics -------------------------------
Merge matching rules         = yes
Number of DFA nodes merged   = 0
Number of ifs generated      = 1
Number of switches generated = 1
Number of labels             = 0
Number of gotos              = 0
Adaptive matching            = disabled
Fast string matching         = disabled
Inline downcasts             = disabled
--------------------------------------------------------------------------
*/
